#if C_GRAPHICSMEDIA_LAB_DMOROZ_C
#/*******************************************************************************
# * (C) Copyright 2003/2004 by Vladimir Vezhnevets <vvp@graphics.cs.msu.su>     *
# *******************************************************************************/
#endif

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Processing.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
//       -      

void BoxFilter(Graphics::TBitmap *in_pImage, Graphics::TBitmap *out_pImage)
{
  //    
  for (int iY = 0; iY < in_pImage->Height; iY ++)
  {
    unsigned char *pcSrcLine, *pcDstLine;

    //     -    
    pcSrcLine = (unsigned char *)in_pImage->ScanLine[iY];
    pcDstLine = (unsigned char *)out_pImage->ScanLine[iY];

    for (int iX = 1; iX < in_pImage->Width - 1; iX ++)
    {
      // blue
      pcDstLine[iX * 3] = (pcSrcLine[iX * 3 - 3] + pcSrcLine[iX * 3] + pcSrcLine[iX * 3 + 3]) / 3.0;
      // green
      pcDstLine[iX * 3 + 1] = (pcSrcLine[iX * 3 - 3 + 1] + pcSrcLine[iX * 3 + 1] + pcSrcLine[iX * 3 + 3 + 1]) / 3.0;
      // red
      pcDstLine[iX * 3 + 2] = (pcSrcLine[iX * 3 - 3 + 2] + pcSrcLine[iX * 3 + 2] + pcSrcLine[iX * 3 + 3 + 2]) / 3.0;
    }
  }
}


//---------------------------------------------------------------------------
//    

void Colorize(Graphics::TBitmap *out_pImage)
{
  for (int iY = 0; iY < out_pImage->Height; iY ++)
  {
    unsigned char *pcSrcLine, *pcDstLine;

    //     -    
    pcDstLine = (unsigned char *)out_pImage->ScanLine[iY];

    for (int iX = 0; iX < out_pImage->Width; iX ++)
    {
      ///      
      // blue
      pcDstLine[iX * 3] = iX % 256;
      // green
      pcDstLine[iX * 3 + 1] = 255 - iX % 256;
      // red
      pcDstLine[iX * 3 + 2] = abs(iX - out_pImage->Width / 2) % 256;
    }
  }
}

 